#!/usr/bin/env python
# -*- coding: utf-8 -*-
# -------------------------------------------------------------------------------
#                     (c) Disabler Production LabAratory
# -------------------------------------------------------------------------------
#
# apt-get install libmissioncontrol-utils

from PyQt4 import QtGui, QtCore
import os

presence_script		 = 'run-standalone.sh dbus-send --type=method_call --dest=org.freedesktop.Notifications /org/freedesktop/Notifications org.freedesktop.Notifications.SystemNoteInfoprint string:"%s"'
message_script		 = 'run-standalone.sh dbus-send --print-reply --type=method_call --dest=org.freedesktop.Notifications /org/freedesktop/Notifications org.freedesktop.Notifications.SystemNoteDialog string:"%s" uint32:0 string:'' 2> /dev/null 1> /dev/null'
bt,ac,acn,acr,tmp_file = {},{},{},{},'tmp'

def readfile(filename):
	fp = file(filename)
	data = fp.read()
	fp.close()
	return data

def sh(cmd):
	cmd = shh(cmd)
	try: os.remove(tmp_file)
	except: pass
	return cmd
	
def shh(cmd):
	try: os.remove(tmp_file)
	except: pass
	try:
		os.system('%s >> %s' % (cmd.encode('utf-8'),tmp_file))
		return readfile(tmp_file)
	except: return None

class ClassWizard(QtGui.QWizard):
	def __init__(self, parent=None):
		super(ClassWizard, self).__init__(parent)
		self.addPage(choose_account())
		self.addPage(setup_account())
		self.addPage(final_page())
		self.setWindowTitle("Jabber account configure")

class choose_account(QtGui.QWizardPage):
	def __init__(self, parent=None):
		super(choose_account, self).__init__(parent)
		global bt,ac,acn,acr
		self.setTitle("Choose Your jabber account")
		self.layout = QtGui.QGridLayout()
		self.account_name = QtGui.QLineEdit("")
		self.account_name.setReadOnly(True)
		self.registerField('account', self.account_name)
		self.layout.addWidget(self.account_name, 0, 0)
		lst = sh('mc-tool list')
		acc = []
		if lst:
			for tmp in lst.split('\n'):
				if tmp[:14] == 'gabble/jabber/': acc.append(tmp)
				#acc.append(tmp)
			if acc:
				for tmp in acc:
					if len(tmp):
						answ = sh('mc-tool show %s' % tmp)
						if answ:
							answ = answ.split('\n')
							ac[tmp] = answ
							for t in answ:
								if 'Normalized: ' in t:
									btn = t.split('Normalized: ')[1]
									acn[tmp] = btn
									acr[btn] = tmp
									bt[tmp] = QtGui.QRadioButton('&%s' % btn)
									bt[tmp].clicked.connect(self.set_account)
				cnt = 1
				for tmp in bt.keys():
					self.layout.addWidget(bt[tmp], cnt, 0)
					cnt += 1
			else:
				self.error_label = QtGui.QLabel('There is no jabber account!')
				self.layout.addWidget(self.error_label, 0, 0)
		else:
			self.error_label = QtGui.QLabel('Error! Can\'t execute shell script!')
			self.layout.addWidget(self.error_label, 0, 0)
		self.setLayout(self.layout)

	def set_account(self):
		global bt,acn
		for tmp in bt.keys():
			if bt[tmp].isChecked():	
				self.account_name.setText(acn[tmp])
				self.completeChanged.emit()
				break
		
	def isComplete(self): return len(self.field('account').toString())

	def validatePage(self): return True

class setup_account(QtGui.QWizardPage):
	def __init__(self, parent=None):
		super(setup_account, self).__init__(parent)
		self.setTitle('Settings for:')
		self.layout = QtGui.QGridLayout()
		self.priority_label = QtGui.QLabel('Priority')
		self.priority = QtGui.QLineEdit('')
		self.registerField('priority', self.priority)
		self.checkButton = QtGui.QPushButton("&Apply")
		self.checkButton.clicked.connect(self.check)
		self.layout.addWidget(self.priority_label, 0, 0)
		self.layout.addWidget(self.priority, 0, 1)
		self.layout.addWidget(self.checkButton, 1,1)
		self.setLayout(self.layout)

	def initializePage(self):
		ac_name = self.field('account').toString()
		ac_id = acr[unicode(ac_name)]
		ac_setts = ac[ac_id]
		priority = '0'
		for t in ac_setts:
			if ') priority = ' in t:
				priority = t.split(') priority = ')[1]
				break
		self.setSubTitle(ac_name)
		self.priority.setText(priority)

	def check(self):
		global ac
		pr = unicode(self.field('priority').toString())
		ac_name = unicode(self.field('account').toString())
		ac_id = acr[ac_name]
		ac_setts = ac[ac_id]
		if pr.isdigit():
			if -128 <= int(pr) <= 127:
				sp = 'Set priority to %s for %s' % (pr,ac_name)
				os.system(presence_script % sp)
				os.system('mc-tool update %s int:priority=%s' % (acr[ac_name],pr))
				for t in range(0,len(ac_setts)):
					if ') priority = ' in ac_setts[t]:
						ac_setts[t] = ac_setts[t].split(') priority = ')[0]+') priority = '+pr
						ac[ac_id] = ac_setts
						break
			else: os.system(presence_script % 'Error in priority! Must be -128..127!')
		else: os.system(presence_script % 'Error in priority! Must be integer!')
		
	def isComplete(self): return True

	def validatePage(self): return True

def final_page():
	def AboutMe(): os.system(message_script % u'© Disabler Production Lab.\ndsy@dsy.name\nhttp://dsy.name'.encode('utf-8'))
	def Donate(): os.system(message_script % u'Send donation to: \n • YandexMoney: 41001384336826\n • WMZ: Z392970180590\n • WMR: R378494692310\n • WME: E164241657651\nBest regards, Disabler'.encode('utf-8'))
	page = QtGui.QWizardPage()
	page.setTitle("Finished")
	label = QtGui.QLabel("You are finished works with account...<br />Have a fun!")
	label.setWordWrap(True)
	layout = QtGui.QVBoxLayout()
	layout.addWidget(label)
	AboutButton = QtGui.QPushButton("&AboutMe")
	AboutButton.clicked.connect(AboutMe) 
	layout.addWidget(AboutButton)
	DonateButton = QtGui.QPushButton("&Donations")
	DonateButton.clicked.connect(Donate) 
	layout.addWidget(DonateButton)
	page.setPixmap(QtGui.QWizard.WatermarkPixmap, QtGui.QPixmap('logo-vert.png'))
	page.setLayout(layout)
	return page

if __name__ == '__main__':
	import sys
	mct = sh('ls /usr/bin/mc-tool').replace('\n','')
	if mct == '/usr/bin/mc-tool':
		app = QtGui.QApplication(sys.argv)
		wizard = ClassWizard()
		wizard.show()
		sys.exit(wizard.exec_())
	else: os.system(message_script % 'Warning! Missed \'mc-tool\'\nType for install:\nsudo apt-get install libmissioncontrol-utils')
